#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <php/main/php.h>
#include <stdio.h>

PHP_FUNCTION(hello_php);
ZEND_BEGIN_ARG_INFO(arginfo_hello_php, 0)
    ZEND_ARG_INFO(0, who)
ZEND_END_ARG_INFO()

PHP_FUNCTION(hello_php2);
ZEND_BEGIN_ARG_INFO(arginfo_hello_php2, 0)
    ZEND_ARG_INFO(0, who)
    ZEND_ARG_INFO(0, howMany)
ZEND_END_ARG_INFO()

// list of custom PHP functions provided by this extension
// set {NULL, NULL, NULL} as the last record to mark the end of list
static zend_function_entry my_functions[] = {
    PHP_FE(hello_php, arginfo_hello_php)
    PHP_FE(hello_php2, arginfo_hello_php2)
    {NULL, NULL, NULL}
};

// the following code creates an entry for the module and registers it with Zend.
zend_module_entry hello_world_module_entry = {
    STANDARD_MODULE_HEADER,
    "hello_world",
    my_functions,
    NULL, // name of the MINIT function or NULL if not applicable
    NULL, // name of the MSHUTDOWN function or NULL if not applicable
    NULL, // name of the RINIT function or NULL if not applicable
    NULL, // name of the RSHUTDOWN function or NULL if not applicable
    NULL, // name of the MINFO function or NULL if not applicable
    NO_VERSION_YET,
    STANDARD_MODULE_PROPERTIES
};

ZEND_GET_MODULE(hello_world)

// implementation of a custom hello_php()
PHP_FUNCTION(hello_php) {
    char text[1024];
    char *who;
    int who_len;
    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &who, &who_len) == FAILURE) {
        return;
    }

    sprintf(text, "Hello %s\n", who);
    RETURN_STRING(text, 1);
}

// implementation of a custom hello_php2()
PHP_FUNCTION(hello_php2) {
    char text[1024];
    char *who;
    long howMany = 1;
    int who_len;
    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s|l", &who, &who_len, &howMany) == FAILURE) {
        return;
    }

    sprintf(text, "Hello %d %s\n", howMany, who);
    RETURN_STRING(text, 1);
}